#include<string.h>
#include <stdlib.h>
#include<stdio.h>
#include"myutil.h"


class _UtilErrer {
  private:
    char *errercode;
  public:
     _UtilErrer();
    ~_UtilErrer();
    void set(char *compartment, char *str);
    char *get();
};
_UtilErrer UtilErrer;

void _UtilErrer::set(char *compartment, char *str)
{
    free(errercode);
    errercode = create_strbuf(20 + strlen(str));
    sprintf(errercode, "[%16s]  %s", compartment, str);
}

char *_UtilErrer::get()
{
    return errercode;
}


_UtilErrer::_UtilErrer()
{
    errercode = (char *) NULL;
}

_UtilErrer::~_UtilErrer()
{
    free(errercode);
}

char *get_utilerrer()
{
    return UtilErrer.get();
}

//char* create_strbuf(int length);
//文字列の領域をmallocで確保する。
//char型文字length文字分の領域を確保する。
//中身はmallocなので必ずfreeすること。
char *create_strbuf(int length)
{
    char *p = ((char *) malloc(length * sizeof(char)));
    if (p == NULL)
        UtilErrer.set("create_strbuf", "Can't create memory buffer");
    return p;
}


void del_linefeed(char *str)
{
    char *p;
    p = strrchr(str, '\n');
    if (p != NULL)
        *p = '\0';
}

bool switchflg(bool flg)
{
    if(flg==true)return false;
    else return true;
}
