#--------------------------
# 解析例
#--------------------------

#● DXF
dxf_nonallaxis "kyokuma.dxf"      #変形前のDXFファイル
dxf_allaxis "kyokuhennkeima.dxf" #最大変形時DXFファイル

#● 周期
cycle 2*3.141592654/(0.14650*100)

#● 表示
angle_x 12.5   #表示アングルx
angle_y 12.5   #表示アングルy
angle_z 0.0    #表示アングルz
positiond_x -0.7 #表示位置x
positiond_y 0.3  #表示位置y
positiond_z 0    #表示位置z

#● 変形
deltap 3 #変形前から最大変形時までの移動量を、ファイルから読み取った値より何倍するか
scale 1.3#上記同様、図形自体のサイズをどうするか（デフォルト：1*1*1の図形が表示できるスケール）

#● AVI
aviout off                                   #avi出力するか否か (on/off)
avi_start 2*3.141592654/(0.14650*100)*10     #表示開始より、何秒時点から出力開始するか
avi_end   2*3.141592654/(0.14650*100)*10*2   #表示開始より、何秒時点まで出力するか
